extern crate rocket;
extern crate rocket_dyn_templates;

use rocket::{get,launch, build, routes};
use rocket::fs::FileServer;
use rocket_dyn_templates::{Template, context};
use std::path::Path;
use std::fs::File;

static ASSETS_DIR:     &str = "./assets";
static GUEST_MESSAGES: &str = "./guests.json";

fn check_file(path: &str) -> bool {
    Path::new(path).exists()
}

#[get("/")]
fn index() -> Template {
    let cx = context! {
        hi: "no",
    };
    Template::render("index", &cx)
}

#[get("/guestbook")]
fn guests() -> Template {
    let cx = context! {
        messages: [
            context!{
                name: "hexlocation",
                date: "12 Jun.",
                body: "<h1>xd1</h1>",
            }
        ]
    };
    Template::render("guest", &cx)
}

#[launch]
fn rocket() -> _ {
    if !check_file(GUEST_MESSAGES) {
        File::create(GUEST_MESSAGES).unwrap();
    }
    build()
        .mount("/", routes![index, guests])
        .mount("/assets", FileServer::from(ASSETS_DIR))
        .attach(Template::fairing())
}

